# ========================================================================
# Copyright 2018 Emory University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ========================================================================
import requests

__author__ = "Gary Lai"


# We should call it Client.
class Client(object):
    def __init__(self):
        self.server_url = "https://elit.cloud/api"

    def decode(self, payload):
        url = '{}/{}/{}'.format(self.server_url, 'public', 'decode')

        r = requests.post(url, json=payload)

        if r.status_code:
            return r.json()
        else:
            return {
                'status': r.status_code,
                'message': r.text
            }
